<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('mendspfenlei.门店id')" prop="mendid">
        <el-input
          v-model="queryParams.mendid"
          :placeholder="$t('mendspfenlei.请输入门店id')"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="$t('mendspfenlei.分类名')" prop="name">
        <el-input
          v-model="queryParams.name"
          :placeholder="$t('mendspfenlei.请输入分类名')"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{$t('mendspfenlei.搜索')}}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{$t('mendspfenlei.重置')}}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:fenlei:export']"
        >{{$t('mendspfenlei.导出')}}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="fenleiList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="id" align="center" prop="id" />
      <!-- <el-table-column label="门店id" align="center" prop="mendid" /> -->
      <el-table-column :label="$t('mendspfenlei.分类名')" align="center" prop="name" />
      <!-- <el-table-column label="分类图片" align="center" prop="img" /> -->
      <el-table-column :label="$t('mendspfenlei.分类图片')" align="center" prop="img" width="100">
        <template slot-scope="scope">
          <image-preview :src="scope.row.img" :width="50" :height="50"/>
        </template>
      </el-table-column>
      <el-table-column :label="$t('mendspfenlei.操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:fenlei:edit']"
          >{{$t('mendspfenlei.查看')}}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改spfenlei对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" :label-width="$t('message.language')=='语言'?'80px':$t('message.language')=='language'?'160px':'160px'">
        <el-form-item :label="$t('mendspfenlei.门店id')" prop="mendid">
          <el-input v-model="form.mendid" :placeholder="$t('mendspfenlei.请输入门店id')" />
        </el-form-item>
        <el-form-item :label="$t('mendspfenlei.分类名')" prop="name">
          <el-input v-model="form.name" :placeholder="$t('mendspfenlei.请输入分类名')" />
        </el-form-item>
        <el-form-item :label="$t('mendspfenlei.分类图片')" prop="img">
          <image-upload v-model="form.img"/>
          <!-- <el-input v-model="form.img" placeholder="请输入分类图片" /> -->
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="cancel">{{$t('mendspfenlei.确定')}}</el-button>
        <el-button @click="cancel">{{$t('mendspfenlei.取消')}}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listFenlei, getFenlei, delFenlei, addFenlei, updateFenlei } from "@/api/system/fenlei";

export default {
  name: "Fenlei",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // spfenlei表格数据
      fenleiList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        mendid: null,
        name: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        mendid: [
          { required: true, message: this.$t('mendspfenlei.门店id不能为空'), trigger: "blur" }
        ],
        name: [
          { required: true, message: this.$t('mendspfenlei.分类名不能为空'), trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询spfenlei列表 */
    getList() {
      this.loading = true;
      listFenlei(this.queryParams).then(response => {
        this.fenleiList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        mendid: null,
        name: null,
        img: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加spfenlei";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getFenlei(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('mendspfenlei.查看门店分类');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateFenlei(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addFenlei(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除spfenlei编号为"' + ids + '"的数据项？').then(function() {
        return delFenlei(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/fenlei/export', {
        ...this.queryParams
      }, `fenlei_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
